using SecureShopContracts.BindingModels;
using SecureShopContracts.ViewModels;
using SecureShopDataModels.Models;

namespace SecureShopListImplement.Models
{
    public class Facilities : IFacilitiesModel
    {
        public int Id { get; private set; }
        public string FacilitiesName { get; private set; } = string.Empty;
        public double Cost { get; set; }

        public static Facilities? Create(FacilitiesBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Facilities()
            {
                Id = model.Id,
                FacilitiesName = model.FacilitiesName,
                Cost = model.Cost
            };
        }

        public void Update(FacilitiesBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            FacilitiesName = model.FacilitiesName;
            Cost = model.Cost;
        }

        public FacilitiesViewModel GetViewModel => new()
        {
            Id = Id,
            FacilitiesName = FacilitiesName,
            Cost = Cost
        };
    }
}